Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 6452)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 6453)
@@ -10,8 +10,9 @@
    !!             2.0  !  2007-12  (C. Ethe, G. Madec) from trcini.pisces.h90
    !!             3.5  !  2012-05  (C. Ethe) Merge PISCES-LOBSTER
-   !!----------------------------------------------------------------------
-#if defined key_pisces || defined key_pisces_reduced
-   !!----------------------------------------------------------------------
-   !!   'key_pisces'                                       PISCES bio-model
+   !!             3.6  !  2015-05  (O. Aumont) PISCES quota
+   !!----------------------------------------------------------------------
+#if defined key_pisces || defined key_pisces_reduced || defined key_pisces_quota
+   !!----------------------------------------------------------------------
+   !!   'key_pisces*'                                       PISCES bio-model
    !!----------------------------------------------------------------------
    !! trc_ini_pisces   : PISCES biochemical model initialisation
@@ -43,9 +44,170 @@
       !!----------------------------------------------------------------------
 
-      IF( lk_p4z ) THEN  ;   CALL p4z_ini   !  PISCES
-      ELSE               ;   CALL p2z_ini   !  LOBSTER
-      ENDIF
+      SELECT CASE ( nn_p4z )
+      !
+        CASE(1)          ;   CALL p2z_ini   !  LOBSTER
+        CASE(2)          ;   CALL p4z_ini   !  PISCES
+        CASE(3)          ;   CALL p5z_ini   !  PISCES QUOTA
+
+      END SELECT
 
    END SUBROUTINE trc_ini_pisces
+
+   SUBROUTINE p5z_ini
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE p5z_ini ***
+      !!
+      !! ** Purpose :   Initialisation of the PISCES biochemical model
+      !!                with variable stoichiometry
+      !!----------------------------------------------------------------------
+#if defined key_pisces_quota 
+      !
+      USE p5zsms          ! Main P4Z routine
+      USE p4zche          !  Chemical model
+      USE p5zsink         !  vertical flux of particulate matter due to sinking
+      USE p4zopt          !  optical model
+      USE p4zsbc          !  Boundary conditions
+      USE p4zfechem       !  Iron chemistry
+      USE p5zrem          !  Remineralisation of organic matter
+      USE p5zpoc          !  Remineralization of organic particles
+      USE p4zligand       !  Remineralization of organic ligands
+      USE p4zflx          !  Gas exchange
+      USE p5zlim          !  Co-limitations of differents nutrients
+      USE p5zprod         !  Growth rate of the 2 phyto groups
+      USE p5zmicro        !  Sources and sinks of microzooplankton
+      USE p5zmeso         !  Sources and sinks of mesozooplankton
+      USE p5zmort         !  Mortality terms for phytoplankton
+      USE p4zlys          !  Calcite saturation
+      USE p5zsed          !  Sedimentation & burial
+      !
+      REAL(wp), SAVE :: sco2   =  2.312e-3_wp
+      REAL(wp), SAVE :: alka0  =  2.423e-3_wp
+      REAL(wp), SAVE :: oxyg0  =  177.6e-6_wp 
+      REAL(wp), SAVE :: po4    =  2.174e-6_wp 
+      REAL(wp), SAVE :: bioma0 =  1.000e-8_wp  
+      REAL(wp), SAVE :: silic1 =  91.65e-6_wp  
+      REAL(wp), SAVE :: no3    =  31.04e-6_wp * 7.625_wp
+      !
+      INTEGER  ::  ierr
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' p5z_ini :   PISCES biochemical model initialisation'
+      IF(lwp) WRITE(numout,*) '             With variable stoichiometry'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+                                                 ! Allocate PISCES arrays
+      ierr =         sms_pisces_alloc()          
+      ierr = ierr +  p4z_che_alloc()
+      ierr = ierr +  p5z_sink_alloc()
+      ierr = ierr +  p4z_opt_alloc()
+      ierr = ierr +  p5z_lim_alloc()
+      ierr = ierr +  p5z_prod_alloc()
+      ierr = ierr +  p5z_rem_alloc()
+      ierr = ierr +  p4z_flx_alloc()
+      ierr = ierr +  p5z_sed_alloc()
+      !
+      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'pisces_alloc: unable to allocate PISCES arrays' )
+      !
+      ryyss    = nyear_len(1) * rday    ! number of seconds per year
+      r1_ryyss = 1. / ryyss
+      !
+      CALL p5z_sms_init       !  Maint routine
+      !                                            ! Time-step
+      ! Set biological ratios
+      ! ---------------------
+      rno3    =  16._wp / 122._wp
+      po4r    =   1._wp / 122._wp
+      o2nit   =  32._wp / 122._wp
+      rdenit  = 105._wp /  16._wp
+      rdenita =   3._wp /  5._wp
+      o2ut    = 133._wp / 122._wp
+      no3rat3 = no3rat3 / rno3
+      po4rat3 = po4rat3 / po4r
+
+      ! Initialization of tracer concentration in case of  no restart 
+      !--------------------------------------------------------------
+      IF( .NOT. ln_rsttr ) THEN  
+         
+         trn(:,:,:,jpdic) = sco2
+         trn(:,:,:,jpdoc) = bioma0
+         trn(:,:,:,jpdon) = bioma0
+         trn(:,:,:,jpdop) = bioma0
+         trn(:,:,:,jptal) = alka0
+         trn(:,:,:,jpoxy) = oxyg0
+         trn(:,:,:,jpcal) = bioma0
+         trn(:,:,:,jppo4) = po4 / po4r
+         trn(:,:,:,jppoc) = bioma0
+         trn(:,:,:,jppon) = bioma0
+         trn(:,:,:,jppop) = bioma0
+#  if ! defined key_kriest
+         trn(:,:,:,jpgoc) = bioma0
+         trn(:,:,:,jpgon) = bioma0
+         trn(:,:,:,jpgop) = bioma0
+         trn(:,:,:,jpbfe) = bioma0 * 5.e-6
+#  else
+         trn(:,:,:,jpnum) = bioma0 / ( 6. * xkr_massp )
+#  endif
+         trn(:,:,:,jpsil) = silic1
+         trn(:,:,:,jpdsi) = bioma0 * 0.15
+         trn(:,:,:,jpgsi) = bioma0 * 5.e-6
+         trn(:,:,:,jpphy) = bioma0
+         trn(:,:,:,jpnph) = bioma0
+         trn(:,:,:,jppph) = bioma0
+         trn(:,:,:,jppic) = bioma0
+         trn(:,:,:,jpnpi) = bioma0
+         trn(:,:,:,jpppi) = bioma0
+         trn(:,:,:,jpdia) = bioma0
+         trn(:,:,:,jpndi) = bioma0
+         trn(:,:,:,jppdi) = bioma0
+         trn(:,:,:,jpzoo) = bioma0
+         trn(:,:,:,jpmes) = bioma0
+         trn(:,:,:,jpfer) = 0.6E-9
+         trn(:,:,:,jpsfe) = bioma0 * 5.e-6
+         trn(:,:,:,jppfe) = bioma0 * 5.e-6
+         trn(:,:,:,jpdfe) = bioma0 * 5.e-6
+         trn(:,:,:,jpnfe) = bioma0 * 5.e-6
+         trn(:,:,:,jpnch) = bioma0 * 12. / 55.
+         trn(:,:,:,jppch) = bioma0 * 12. / 55.
+         trn(:,:,:,jpdch) = bioma0 * 12. / 55.
+         trn(:,:,:,jpno3) = no3
+         trn(:,:,:,jpnh4) = bioma0
+#if defined key_ligand
+         trn(:,:,:,jplgw) = 0.6E-9
+         trn(:,:,:,jpfep) = 0. * 5.e-6
+#endif
+
+         ! initialize the half saturation constant for silicate
+         ! ----------------------------------------------------
+         xksi(:,:)    = 2.e-6
+         xksimax(:,:) = xksi(:,:)
+      END IF
+
+      CALL p5z_sink_init      !  vertical flux of particulate organic matter
+      CALL p4z_opt_init       !  Optic: PAR in the water column
+      CALL p5z_lim_init       !  co-limitations by the various nutrients
+      CALL p5z_prod_init      !  phytoplankton growth rate over the global ocean.
+      CALL p4z_sbc_init       !  boundary conditions
+      CALL p4z_fechem_init    !  Iron chemistry
+      CALL p5z_rem_init       !  remineralisation
+      CALL p5z_poc_init       !  remineralisation of organic particles
+#if defined key_ligand
+      CALL p4z_ligand_init    !  remineralisation of organic ligands
+#endif
+      CALL p5z_mort_init      !  phytoplankton mortality 
+      CALL p5z_micro_init     !  microzooplankton
+      CALL p5z_meso_init      !  mesozooplankton
+      CALL p4z_lys_init       !  calcite saturation
+      CALL p4z_flx_init       !  gas exchange 
+
+      ndayflxtr = 0
+
+      IF(lwp) WRITE(numout,*) 
+      IF(lwp) WRITE(numout,*) 'Initialization of PISCES tracers done'
+      IF(lwp) WRITE(numout,*) 
+#endif
+      !
+   END SUBROUTINE p5z_ini
 
    SUBROUTINE p4z_ini
@@ -64,4 +226,6 @@
       USE p4zfechem       !  Iron chemistry
       USE p4zrem          !  Remineralisation of organic matter
+      USE p4zpoc          !  Remineralisation of organic particles
+      USE p4zligand       !  Remineralization of organic ligands
       USE p4zflx          !  Gas exchange
       USE p4zlim          !  Co-limitations of differents nutrients
@@ -74,14 +238,12 @@
       !
       REAL(wp), SAVE :: sco2   =  2.312e-3_wp
-      REAL(wp), SAVE :: alka0  =  2.426e-3_wp
-      REAL(wp), SAVE :: oxyg0  =  177.6e-6_wp 
-      REAL(wp), SAVE :: po4    =  2.165e-6_wp 
-      REAL(wp), SAVE :: bioma0 =  1.000e-8_wp  
-      REAL(wp), SAVE :: silic1 =  91.51e-6_wp  
-      REAL(wp), SAVE :: no3    =  30.9e-6_wp * 7.625_wp
-      !
-      INTEGER  ::  ji, jj, jk, ierr
-      REAL(wp) ::  zcaralk, zbicarb, zco3
-      REAL(wp) ::  ztmas, ztmas1
+      REAL(wp), SAVE :: alka0  =  2.423e-3_wp
+      REAL(wp), SAVE :: oxyg0  =  177.6e-6_wp
+      REAL(wp), SAVE :: po4    =  2.174e-6_wp
+      REAL(wp), SAVE :: bioma0 =  1.000e-8_wp
+      REAL(wp), SAVE :: silic1 =  91.65e-6_wp
+      REAL(wp), SAVE :: no3    =  31.04e-6_wp * 7.625_wp
+      !
+      INTEGER  ::  ierr
       !!----------------------------------------------------------------------
 
@@ -91,8 +253,9 @@
 
                                                  ! Allocate PISCES arrays
-      ierr =         sms_pisces_alloc()          
+      ierr =         sms_pisces_alloc()
       ierr = ierr +  p4z_che_alloc()
       ierr = ierr +  p4z_sink_alloc()
       ierr = ierr +  p4z_opt_alloc()
+      ierr = ierr +  p4z_lim_alloc()
       ierr = ierr +  p4z_prod_alloc()
       ierr = ierr +  p4z_rem_alloc()
@@ -109,5 +272,4 @@
       CALL p4z_sms_init       !  Maint routine
       !                                            ! Time-step
-
       ! Set biological ratios
       ! ---------------------
@@ -121,6 +283,6 @@
       ! Initialization of tracer concentration in case of  no restart 
       !--------------------------------------------------------------
-      IF( .NOT. ln_rsttr ) THEN  
-         
+      IF( .NOT. ln_rsttr ) THEN
+
          trn(:,:,:,jpdic) = sco2
          trn(:,:,:,jpdoc) = bioma0
@@ -151,4 +313,8 @@
          trn(:,:,:,jpno3) = no3
          trn(:,:,:,jpnh4) = bioma0
+#if defined key_ligand
+         trn(:,:,:,jplgw) = 0.6E-9
+         trn(:,:,:,jpfep) = 0. * 5.e-6
+#endif
 
          ! initialize the half saturation constant for silicate
@@ -157,5 +323,4 @@
          xksimax(:,:) = xksi(:,:)
       END IF
-
 
       CALL p4z_sink_init      !  vertical flux of particulate organic matter
@@ -166,4 +331,8 @@
       CALL p4z_fechem_init    !  Iron chemistry
       CALL p4z_rem_init       !  remineralisation
+      CALL p4z_poc_init       !  remineralization of organic particles
+#if defined key_ligand
+      CALL p4z_ligand_init    !  remineralisation of organic ligands
+#endif
       CALL p4z_mort_init      !  phytoplankton mortality 
       CALL p4z_micro_init     !  microzooplankton
@@ -174,7 +343,7 @@
       ndayflxtr = 0
 
-      IF(lwp) WRITE(numout,*) 
+      IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) 'Initialization of PISCES tracers done'
-      IF(lwp) WRITE(numout,*) 
+      IF(lwp) WRITE(numout,*)
 #endif
       !
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 6452)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 6453)
@@ -8,8 +8,9 @@
    !!             1.0  !  2003-08 (C. Ethe)  module F90
    !!             2.0  !  2007-12  (C. Ethe, G. Madec) from trcnam.pisces.h90
+   !!             3.6  !  2015-05  (O. Aumont) PISCES quota
    !!----------------------------------------------------------------------
-#if defined key_pisces || defined key_pisces_reduced
+#if defined key_pisces || defined key_pisces_reduced || defined key_pisces_quota
    !!----------------------------------------------------------------------
-   !!   'key_pisces'   :                                   PISCES bio-model
+   !!   'key_pisces*'  :                                   PISCES bio-model
    !!----------------------------------------------------------------------
    !! trc_nam_pisces       : PISCES model namelist read
@@ -66,4 +67,6 @@
 #if defined key_pisces
       IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read PISCES namelist'
+#elif defined key_pisces_quota
+      IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read PISCES-QUOTA namelist'
 #else
       IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read LOBSTER namelist'
@@ -123,5 +126,5 @@
 #if defined key_pisces_reduced
 
-      IF( ( .NOT.lk_iomput .AND. ln_diabio ) .OR. lk_trdmxl_trc ) THEN
+      IF( ( .NOT.lk_iomput .AND. ln_diabio ) .OR. lk_trdmld_trc ) THEN
          !
          ! Namelist nampisdbi
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 6452)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 6453)
@@ -6,12 +6,14 @@
    !! History :   1.0  !  2004-03 (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.6  !  2015-05  (O. Aumont) PISCES quota
    !!----------------------------------------------------------------------
-#if defined key_pisces || defined key_pisces_reduced
+#if defined key_pisces || defined key_pisces_reduced || defined key_pisces_quota
    !!----------------------------------------------------------------------
-   !!   'key_pisces'                                       PISCES bio-model
+   !!   'key_pisces*'                                       PISCES bio-model
    !!----------------------------------------------------------------------
    !!   trcsms_pisces        :  Time loop of passive tracers sms
    !!----------------------------------------------------------------------
    USE par_pisces
+   USE p5zsms
    USE p4zsms
    USE p2zsms
@@ -48,7 +50,11 @@
       !!---------------------------------------------------------------------
       !
-      IF( lk_p4z ) THEN  ;   CALL p4z_sms( kt )   !  PISCES
-      ELSE               ;   CALL p2z_sms( kt )   !  LOBSTER
-      ENDIF
+      SELECT CASE ( nn_p4z )
+
+      CASE(1)       ;        CALL p2z_sms( kt )   !  LOBSTER
+      CASE(2)       ;        CALL p4z_sms( kt )   !  PISCES
+      CASE(3)       ;        CALL p5z_sms( kt )   !  PISCES with variable stoichiometry
+
+      END SELECT
 
       !
Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90	(revision 6452)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/NEMO/TOP_SRC/PISCES/trcwri_pisces.F90	(revision 6453)
@@ -5,8 +5,9 @@
    !!======================================================================
    !! History :   1.0  !  2009-05 (C. Ethe)  Original code
+   !!             3.6  !  2015-05  (O. Aumont) PISCES quota
    !!----------------------------------------------------------------------
-#if defined key_top && defined key_iomput && ( defined key_pisces || defined key_pisces_reduced )
+#if defined key_top && defined key_iomput && ( defined key_pisces || defined key_pisces_reduced || defined key_pisces_quota)
    !!----------------------------------------------------------------------
-   !!   'key_pisces or key_pisces_reduced'                     PISCES model
+   !!   'key_pisces*'                     PISCES model
    !!----------------------------------------------------------------------
    !! trc_wri_pisces   :  outputs of concentration fields
@@ -30,8 +31,7 @@
       !! ** Purpose :   output passive tracers fields 
       !!---------------------------------------------------------------------
-      CHARACTER (len=20)           :: cltra
-      REAL(wp)                     :: zfact
-      INTEGER                      :: ji, jj, jk, jn
-      REAL(wp), DIMENSION(jpi,jpj) :: zdic, zo2min, zdepo2min
+      CHARACTER (len=20)   :: cltra
+      REAL(wp)             :: zrfact
+      INTEGER              :: jn
       !!---------------------------------------------------------------------
  
@@ -41,43 +41,23 @@
       DO jn = jp_pcs0, jp_pcs1
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-         CALL iom_put( cltra, trn(:,:,:,jn) )
+         IF( lk_vvl ) THEN
+            CALL iom_put( cltra, trn(:,:,:,jn) * fse3t_n(:,:,:) )
+         ELSE
+            CALL iom_put( cltra, trn(:,:,:,jn) )
+         ENDIF
+         CALL iom_put( cltra, trn(:,:,:,jn) * zrfact )
       END DO
 #else
       DO jn = jp_pcs0, jp_pcs1
-         zfact = 1.0e+6 
-         IF( jn == jpno3 .OR. jn == jpnh4 ) zfact = rno3 * 1.0e+6 
-         IF( jn == jppo4  )                 zfact = po4r * 1.0e+6
+         zrfact = 1.0e+6 
+         IF( jn == jpno3 .OR. jn == jpnh4 ) zrfact = rno3 * 1.0e+6 
+         IF( jn == jppo4  )                 zrfact = po4r * 1.0e+6
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
-         IF( iom_use( cltra ) )  CALL iom_put( cltra, trn(:,:,:,jn) * zfact )
+         IF( lk_vvl ) THEN
+            CALL iom_put( cltra, trn(:,:,:,jn) * fse3t_n(:,:,:) * zrfact )
+         ELSE
+            CALL iom_put( cltra, trn(:,:,:,jn) * zrfact )
+         ENDIF
       END DO
-
-      IF( iom_use( "INTDIC" ) ) THEN                     !   DIC content in kg/m2
-         zdic(:,:) = 0.
-         DO jk = 1, jpkm1
-            zdic(:,:) = zdic(:,:) + trn(:,:,jk,jpdic) * fse3t(:,:,jk) * tmask(:,:,jk) * 12.
-         ENDDO
-         CALL iom_put( 'INTDIC', zdic )     
-      ENDIF
-      !
-      IF( iom_use( "O2MIN" ) .OR. iom_use ( "ZO2MIN" ) ) THEN  ! Oxygen minimum concentration and depth 
-         zo2min   (:,:) = trn(:,:,1,jpoxy) * tmask(:,:,1)
-         zdepo2min(:,:) = fsdepw(:,:,1)    * tmask(:,:,1)
-         DO jk = 2, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  IF( tmask(ji,jj,jk) == 1 ) then
-                     IF( trn(ji,jj,jk,jpoxy) < zo2min(ji,jj) ) then
-                        zo2min   (ji,jj) = trn(ji,jj,jk,jpoxy)
-                        zdepo2min(ji,jj) = fsdepw(ji,jj,jk)
-                     ENDIF
-                  ENDIF
-               END DO
-            END DO
-         END DO
-         !
-         CALL iom_put('O2MIN' , zo2min     )                              ! oxygen minimum concentration
-         CALL iom_put('ZO2MIN', zdepo2min  )                              ! depth of oxygen minimum concentration
-          !
-      ENDIF
 #endif
       !
